import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ClientHandlerThread extends Thread {
    private final Socket socket;
    private final BufferedReader from_client;
    private final PrintWriter to_client;
    private static int num_instances = 0;
    private int instance_number = ++num_instances;
    private final SimpleLogger logger = new SimpleLogger("ClientHandlerThread " + instance_number);
	private static final SimpleDateFormat date_format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS Z");

	public ClientHandlerThread(Socket socket, BufferedReader from_client, PrintWriter to_client) {
        this.socket = socket;
        this.from_client = from_client;
        this.to_client = to_client;
	}
	
	public void run() {
		Date now = new Date();
		String formatted_date = date_format.format(now);
		String line = "DATE " + formatted_date;
		to_client.println(line);
		to_client.close();
		try {
			from_client.close();
			socket.close();
		} catch (IOException e) {
			logger.log("IOException (" + e + ") when closing from_client");
		}
	} // run
} // class ClientHandlerThread
